<!-- 通知公告 -->
<script lang="ts" setup>
import { Delete } from '@element-plus/icons-vue'
import { ElLoading } from 'element-plus'
import type { Ref } from 'vue'
// import tableHeader from './tableHeader.vue'
import addNotice from './noteAdd.vue'
import noticeDetail from './noticeDetail.vue'
import type { noticeType } from './notice-interface'
import { getNoticeeApi } from '@/api/system/notice'
import type { TableColumn } from '@/components/NormalTable/table_interface'
import { exportExcel } from '@/utils/exportXlsx'
const searchQuery = reactive({
  noticeNo: '', // 编号
  noticePublisher: '', // 发布人
  noticeTime: '', // 发布时间
  noticeTitle: '', // 标题
  limit: 10,
  offset: 1,
}) // 查询参数
const loadingTable = ref<boolean>(false) // 表格loading
const total = ref<number>(0) // 数据总条数
const columns: Ref<TableColumn[]> = ref([])
columns.value = [
  {
    text: '编号',
    value: 'noticeNo',
    align: 'center',
  },
  {
    text: '标题',
    value: 'noticeTitle',
    align: 'center',
  },
  {
    text: '发布人',
    value: 'noticePublisher',
    align: 'center',
  },
  {
    text: '内容描述',
    value: 'noticeSketch',
    align: 'center',
  },
  {
    text: '发布时间',
    value: 'noticeTime',
    align: 'center',
  },
] // 表格
const list = ref([]) // 表格数据
// 获取通知公告列表
const getNoticeList = () => {
  getNoticeeApi(searchQuery).then((res) => {
    total.value = res.data.total
    list.value = res.data.rows
  })
}
// 页数发生变化后的操作，可能是页码变化，可能是每页容量变化，此函数必写
const changePage = (val: { size?: number; page?: number }) => {
  if (val && val.size) {
    searchQuery.limit = val.size
  }
  if (val && val.page) {
    searchQuery.offset = val.page
  }
  getNoticeList()
}

// 重置查询条件
const resetSearchQuery = () => {
  searchQuery.noticeNo = ''
  searchQuery.noticePublisher = ''
  searchQuery.noticeTime = ''
  searchQuery.noticeTitle = ''
}
// 查询
const search = () => {
  getNoticeList()
}
// 重置
const reset = () => {
  resetSearchQuery()
  search()
}
const addDialog = ref() // 添加弹窗组件
// 新建
const add = () => {
  addDialog.value.initDialog()
}
const detailDialog = ref() // 详情组件弹窗
// 详情
const detail = (row: noticeType) => {
  detailDialog.value.initDialog(row)
}
// 导出
const exportExcelBtn = () => {
  const loading = ElLoading.service({
    lock: true,
    text: 'Loading',
    background: 'rgba(255, 255, 255, 0.8)',
  })
  getNoticeeApi({ ...searchQuery, limit: 9999999, offset: 1 }).then((res) => {
    if (res.code === 200) {
      exportExcel({
        json: res.data.rows.map((item: noticeType, index: number) => ({ index: index + 1, noticeNo: item.noticeNo, noticeTitle: item.noticeTitle, noticePublisher: item.noticePublisher, noticeSketch: item.noticeSketch, noticeTime: item.noticeTime })),
        name: '通知公告',
        titleArr: ['序号', '编号', '标题', '发布人', '内容描述', '发布时间'],
        sheetName: 'sheet1',
      })
    }
    loading.close()
  }).catch((_) => {
    loading.close()
  })
}
// 打印
const print = () => {

}
onMounted(() => {
  getNoticeList()
})
</script>

<template>
  <!-- 布局 -->
  <app-container>
    <!-- 筛选条件 -->
    <search-area @search="search">
      <search-item>
        <el-input v-model.trim="searchQuery.noticeNo" placeholder="请输入编号" clearable class="w-50 m-2 normal-input" />
      </search-item>
      <search-item>
        <el-input v-model.trim="searchQuery.noticeTitle" placeholder="请输入标题" clearable class="w-50 m-2 normal-input" />
      </search-item>
      <search-item>
        <el-input
          v-model.trim="searchQuery.noticePublisher" placeholder="请输入发布人" clearable
          class="w-50 m-2 normal-input"
        />
      </search-item>
      <search-item>
        <el-date-picker
          v-model="searchQuery.noticeTime" type="date" format="YYYY-MM-DD" value-format="YYYY-MM-DD"
          placeholder="发布时间"
        />
      </search-item>
      <template #btns>
        <el-button class="filter-item" type="info" :icon="Delete" :style="{ marginTop: '-10px' }" @click="reset">
          重置
        </el-button>
      </template>
    </search-area>
    <table-container>
      <template #btns-right>
        <el-button type="primary" @click="add">
          新建
        </el-button>
        <el-button type="primary" @click="exportExcelBtn">
          导出
        </el-button>
        <el-button type="primary" @click="print">
          打印
        </el-button>
      </template>
      <!-- 表格区域 -->
      <normal-table
        :data="list" :total="total" :columns="columns" :query="searchQuery"
        :list-loading="loadingTable" @change="changePage"
      >
        <template #preColumns>
          <el-table-column label="#" width="55" align="center">
            <template #default="scope">
              {{ (searchQuery.offset - 1) * searchQuery.limit + scope.$index + 1 }}
            </template>
          </el-table-column>
        </template>
        <template #columns>
          <el-table-column label="操作" align="center" width="90">
            <template #default="{ row }">
              <el-button @click="detail(row)">
                查看
              </el-button>
            </template>
          </el-table-column>
        </template>
      </normal-table>
    </table-container>
    <add-notice ref="addDialog" @reset-data="getNoticeList" />
    <notice-detail ref="detailDialog" />
  </app-container>
</template>

<style lang="scss" scoped>
.normal-input {
  width: 180px !important;
}
</style>
